#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int gr(vector<double> b, double x){
    int l  = 0, r = b.size()-1;
    while(l < r){
        int m = (l+r)/2+1;
        if(b[m] == x) return m;
        if(b[m] < x) r = m-1;
        if(b[m] > x) l = m+1;
    }
    return -3;
}

int main()
{
    int n; double a, r;
    cin >> n;
    vector<double> b(n, 0);
    for(int i = 0; i < n; i++){
        cin >> a;
        if(i == 0) b[i] = a;
        if(i) b[i] =  a+ b[i-1];
    }

    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> a >> r;
        double c;
 c = sqrt(a*a + r*r);
        if(c > b[n-1]) cout << "izvan" << endl;
        else if(gr(b, c) >= 0){
            cout << gr(b,c) << endl;
        }
        else cout << upper_bound(b.begin(),b.end(),c)- b.begin() << endl;
    }
    return 0;
}