#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int gr(vector<int> b, int x){
    int l  = 0, r = b.size()-1;
    while(l < r){
        int m = (l+r)/2+1;
        if(b[m] == x) return m;
        if(b[m] < x) r = m-1;
        if(b[m] > x) l = m+1;
    }
    return -3;
}

int main()
{
    int n; double a, r;
    cin >> n;
    vector<double> b(n, 0);
    for(int i = 0; i < n; i++){
        cin >> a;
        b[i] = a;
        if(i) b[i] += b[i-1];
    }
    sort(b.begin(), b.end());
    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> a >> r;
        double c;
 c = sqrt(a*a + r*r); int j;
        for(j = 0; j < b.size(); j++){
            if(b[j] >= c){
                cout << j << endl;
                break;
            }

        }
        if(j == b.size()) cout << "izvan" << endl;
    }
    return 0;
}