#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

void unos1(int n, double *x){
    cin >> x[0];
    for(int i = 1; i < n; i++){
        double d;
        cin >> d;
        x[i] = x[i - 1] + d;
    }
}

void unos2(int n, double *x){
    for(int i = 0; i < n; i++){
        double a,b;
        cin >> a >> b;
        x[i] = sqrt(a*a + b*b);
    }
}

void quickSort(double *x, int p, int q){
    int i = p, j = q;
    double pivot = x[(i+j)/2];
    while(i <= j){
        for(i; x[i] < pivot; i++);
        for(j; x[j] > pivot; j--);
        if(i <= j){
            double pom = x[i];
            x[i] = x[j];
            x[j] = pom;
            i++;
            j--;
        }
    }
    if(i < q)
        quickSort(x, i, q);
    if(j > p)
        quickSort(x, p, j);
}

int main(){
    int n, m;
    double *d, *x;
    cin >> n;
    d = new double[n];
    unos1(n,d);
    cin >> m;
    x = new double[m];
    unos2(m,x);
    //quickSort(x, 0, m-1);
    int j = 0;
    bool izvan = false;
    for(int i = 0; i < m; i++){
        izvan = true;
        for(j = 0; j < n; j++){
            if(d[j]>=x[i]){
                cout << j << endl;
                izvan = false;
                break;
            }
        }
        if(izvan)
            cout << "izvan" << endl;
    }
    delete[] d;
    delete[] x;
    return 0;
}