#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

void unos1(int n, double *x){
    cin >> x[0];
    for(int i = 1; i < n; i++){
        double d;
        cin >> d;
        x[i] = x[i - 1] + d;
    }
}

void unos2(int n, double *x){
    for(int i = 0; i < n; i++){
        double a,b;
        cin >> a >> b;
        x[i] = sqrt(a*a + b*b);
    }
}

void quickSort(double *x, int *rang, int p, int q){
    int i = p, j = q;
    double pivot = x[(i+j)/2];
    while(i <= j){
        for(i; x[i] < pivot; i++);
        for(j; x[j] > pivot; j--);
        if(i <= j){
            double pom = x[i];
            x[i] = x[j];
            x[j] = pom;
            int p = rang[i];
            rang[i]=rang[j];
            rang[j]=p;
            i++;
            j--;
        }
    }
    if(i < q)
        quickSort(x, rang, i, q);
    if(j > p)
        quickSort(x, rang, p, j);
}

int main(){
    int n, m, *rang, *y;
    double *d, *x;
    cin >> n;
    d = new double[n];
    unos1(n,d);
    cin >> m;
    x = new double[m];
    y = new int[m];
    rang = new int[m];
    for(int i = 0; i < m; i++)
        rang[i]=i;
    unos2(m,x);
    quickSort(x, rang, 0, m-1);
    int j = 0;
    bool izvan = false;
    for(int i = 0; i < m; i++){
        izvan = true;
        for(j = 0; j < n; j++){
            if(d[j]>=x[i]){
                y[rang[i]] = j;
                izvan = false;
                break;
            }
        }
        if(izvan)
            y[rang[i]]=-1;
    }
    for(int i=0;i<m;i++){
        if(y[i]==-1)
            cout << "izvan" << endl;
        else
            cout << y[i] << endl;
    }
    delete[] d;
    delete[] x;
    delete[] y;
    delete[] rang;
    return 0;
}