using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pikado
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] spl;
            double x, y, d;
            int brojPrstena = int.Parse(Console.ReadLine());
            double trenPp = 0;
            List<double> prsteni = new List<double>();
            for (int i = 0; i < brojPrstena; i++)
                prsteni.Add(trenPp += double.Parse(Console.ReadLine()));

            int brojPogodaka = int.Parse(Console.ReadLine());
            List<int> prstenPogotka = new List<int>();
            for (int i = 0; i < brojPogodaka; i++)
            {
                spl = Console.ReadLine().Split(' ');
                x = double.Parse(spl[0]);
                y = double.Parse(spl[1]);
                d = Math.Sqrt(x * x + y * y);
                // ici od 0 do N daje n^2 brzinu
                // ovde koristiti binarnu selekciju - proveriti sredinu i broj,
                // zatim rekurzivno traziti levo ili desno od te sredine
                // ovo daje log n brzinu - sto je MNOGO bolje od n^2
                if (d > trenPp)
                {
                    prstenPogotka.Add(-1);
                    continue;
                }
                int levo = 0;
                int desno = brojPrstena - 1;
                while (levo != desno)
                {
                    int sredina = levo + (desno - levo) / 2;
                    if (prsteni[sredina] > d) desno = sredina;
                    else levo = 1 + sredina;
                }
                prstenPogotka.Add(levo);
            }
            for (int i = 0; i < brojPogodaka; i++)
                Console.WriteLine(prstenPogotka[i] != -1 ? prstenPogotka[i].ToString() : "izvan");
        }
    }
}