#include <stdio.h>
#include <math.h>

typedef struct point{
    float x;
    float y;
} POINT;

float distance(POINT pointA, POINT pointB){
    return sqrt((pointA.x-pointB.x)*(pointA.x-pointB.x) + (pointA.y-pointB.y)*(pointA.y-pointB.y));
}

int main(){
    int amountOfCircles;
    scanf("%d", &amountOfCircles);
    float poluprecnik[amountOfCircles];
    int i;
    for(i=0;i<amountOfCircles;i++){
        scanf("%f",&poluprecnik[i]);
    }
    int amountOfPoints;
    scanf("%d", &amountOfPoints);
    POINT points[amountOfPoints];
    for(i=0;i<amountOfPoints;i++){
        scanf("%f",&points[i].x);
        scanf("%f",&points[i].y);
    }

    POINT origin;
    origin.x = 0.0;
    origin.y = 0.0;
    int j, result;
    float temp;
    for(i=0;i<amountOfCircles;i++){
        for(j=0;j<amountOfCircles;j++){
            if(poluprecnik[j+1]<poluprecnik[j]){
                temp = poluprecnik [j];
                poluprecnik[j] = poluprecnik[j+1];
                poluprecnik[j+1] = temp;
            }
        }
    }
    for(i=0;i<amountOfCircles;i++){
        for(j=0;j<amountOfCircles;j++){
            if(poluprecnik[j+1]<poluprecnik[j]){
                temp = poluprecnik [j];
                poluprecnik[j] = poluprecnik[j+1];
                poluprecnik[j+1] = temp;
            }
        }
    }

    for(i=0;i<amountOfPoints;i++){
        for(j=0;j<amountOfCircles;j++){
            if(j==0){
                if(distance(origin, points[i])<poluprecnik[0]){
                    printf("0\n");
                    break;
                }
            } else {
                if((distance(origin, points[i])>poluprecnik[j-1])&&(distance(origin, points[i])<poluprecnik[j])){
                    printf("%d\n", j-1);
                    break;
                } else if(distance(origin, points[i])>poluprecnik[amountOfCircles-1]){
                    printf("izvan\n");
                    break;
                }
            }
        }
    }

    return 0;
}